title=getTitle();
getVoxelSize(w, h, d, unit);
run("Median 3D...", "x=2 y=2 z=2");
membrane=4;
//-------------------------------------------------------------------------------------------------------------
//Gets the cells shapes
run("Duplicate...", "title=cells duplicate");
run("Minimum 3D...", "x=2 y=2 z=2");//Separate cells
run("Maximum 3D...", "x=2 y=2 z=2");
run("Duplicate...", "title=outliers duplicate");
run("Remove Outliers...", "radius=15 threshold=20 which=Bright stack");
imageCalculator("Subtract stack", "cells","outliers");
selectWindow("outliers");
close();
selectWindow("cells");
run("ManualThresholding ", "threshold=0 stack");
run("Options...", "iterations=1 count=1 black do=Nothing");//Insure black background before filing holes
run("Fill Holes", "stack");
//-----------------------------------------------------------------------
run("Duplicate...", "title=holes duplicate");
run("Spherical cells detection", "radius=10 membrane="+membrane);//Gets spheres of radius 10
selectWindow("Spheres");
rename("10");
//----------------------------------------------------------------------------------
selectWindow("holes");
run("Spherical cells detection", "radius=9 membrane="+membrane);
imageCalculator("OR stack", "10","Spheres");
selectWindow("Spheres");
close();
//----------------------------------------------------------------------------------
selectWindow("holes");
run("Spherical cells detection", "radius=8 membrane="+membrane);
imageCalculator("OR stack", "10","Spheres");
selectWindow("Spheres");
close();
//----------------------------------------------------------------------------------
selectWindow("holes");
run("Spherical cells detection", "radius=7 membrane="+membrane);
imageCalculator("OR stack", "10","Spheres");
selectWindow("Spheres");
close();
//----------------------------------------------------------------------------------
selectWindow("holes");
run("Spherical cells detection", "radius=6 membrane="+membrane);
imageCalculator("OR stack", "10","Spheres");
selectWindow("Spheres");
close();
//----------------------------------------------------------------------------------
selectWindow("holes");
run("Spherical cells detection", "radius=5 membrane="+membrane);
imageCalculator("OR stack", "10","Spheres");
selectWindow("Spheres");
close();
//----------------------------------------------------------------------------------
selectWindow("holes");
run("Spherical cells detection", "radius=4 membrane="+membrane);
imageCalculator("OR stack", "10","Spheres");
selectWindow("Spheres");
close();
//----------------------------------------------------------------------------------
/*selectWindow("holes");
run("Spherical cells detection", "radius=3 membrane="+membrane);
imageCalculator("OR stack", "10","Spheres");
selectWindow("Spheres");
close();*/
//-------------------------------------------------------------------------------
//Still to develop mixing of very close seeds
selectWindow("10");
run("Label3D18C ");
//---------------------------------------------------------------------------------------------------------------------
selectWindow("10");
close();
selectWindow("Label 3D");
minVol=3;
maxVol=99999999;//A very big value is employed as maximal volume
setVoxelSize(w, h, d, unit);
run("VolumeFilter ","minimum="+minVol+" maximum="+maxVol+" show");
